/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#pragma comment(copyright,"5765-543 (C) Copyright IBM Corp. 2008 @(#) 1.1 src/ppe/hpct/source/examples/psigma/mio/rtc.c, ppe.hpct, ppe_rhya, rhya0837c 08/09/16 10:33:45")
#if defined(xLinux) || defined(pLinux)

#include <sys/time.h>
#include <unistd.h>
#include <stdio.h>

struct timeval  tv ;
struct timezone tz ;

double
rtc()
{
static double start=-1.0 ;
int ret ;
double dret ;
   ret = gettimeofday( &tv, &tz ) ;
   dret = (double)tv.tv_sec + ((double)(tv.tv_usec))*.000001 ;
   if( start == -1.0 ) start = dret ;
   dret = dret - start ;
   return(dret);

}

#endif

#if defined(aix)
#include <stdio.h>
#include <sys/time.h>
 
double
rtc(void)
{
static int first=1;
static timebasestruct_t start ;
timebasestruct_t finish;
double ret ;
int secs, n_secs;
 
   if( first ) {
      /* get the time before the operation begins */
      read_real_time(&start, TIMEBASE_SZ);
      time_base_to_time(&start, TIMEBASE_SZ);
      ret = 0 ;
      first = 0 ;
   } else {
      read_real_time(&finish, TIMEBASE_SZ);
      time_base_to_time(&finish, TIMEBASE_SZ);
      secs = finish.tb_high - start.tb_high;
      n_secs = finish.tb_low - start.tb_low;
      if (n_secs < 0)  {
         secs--;
         n_secs += 1000000000;
         }
      ret = (double)secs ;
      ret += n_secs*.000000001 ;
   }
   return(ret);
}
#endif
