C IBM_PROLOG_BEGIN_TAG 
C This is an automatically generated prolog. 
C  
C  
C  
C Licensed Materials - Property of IBM 
C  
C (C) COPYRIGHT International Business Machines Corp. 2008 
C All Rights Reserved 
C  
C US Government Users Restricted Rights - Use, duplication or 
C disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
C  
C IBM_PROLOG_END_TAG 
C
      SUBROUTINE CALC3
C
C         TIME SMOOTHER
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
#include "f_hpc.h"

      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
      integer ierr
      integer omp_get_thread_num

C
C        TIME SMOOTHING AND UPDATE FOR NEXT CYCLE
C

C SPEC removed CCMIC$ DO GLOBAL
C$OMP PARALLEL
C$OMP&SHARED (ALPHA,M,N,U,V,P,UNEW,VNEW,PNEW,UOLD,VOLD,POLD)
C$OMP&SHARED (JS,JE)
C$OMP&PRIVATE (I,J)
      I = 30+omp_get_thread_num()
      call f_hpmtstart( I, "Loop 300" )
      CALL f_hpm_errchk
C$OMP DO
      DO 300 J=js,je
      DO 300 I=1,M
      UOLD(I,J) = U(I,J)+ALPHA*(UNEW(I,J)-2.*U(I,J)+UOLD(I,J))
      VOLD(I,J) = V(I,J)+ALPHA*(VNEW(I,J)-2.*V(I,J)+VOLD(I,J))
      POLD(I,J) = P(I,J)+ALPHA*(PNEW(I,J)-2.*P(I,J)+POLD(I,J))
      U(I,J) = UNEW(I,J)
      V(I,J) = VNEW(I,J)
      P(I,J) = PNEW(I,J)
  300 CONTINUE
      call f_hpmtstop( 30+omp_get_thread_num())
      CALL f_hpm_errchk
C$OMP END PARALLEL
CME-------------------------------------------

C
C     PERIODIC CONTINUATION
C
CME----------------------------------------------
      DO 320 J=1,N
      UOLD(M+1,J) = UOLD(1,J)
      VOLD(M+1,J) = VOLD(1,J)
      POLD(M+1,J) = POLD(1,J)
      U(M+1,J) = U(1,J)
      V(M+1,J) = V(1,J)
      P(M+1,J) = P(1,J)
  320 CONTINUE
CME------------------------------------------------------
      call f_hpmstart( 17, "MPI in Calc3" )
      CALL f_hpm_errchk
      if(taskid.eq.numtasks-1)then                        
      cALL mpi_irecv(v(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(u(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      cALL mpi_irecv(p(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      cALL mpi_irecv(vold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      cALL mpi_irecv(uold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      cALL mpi_irecv(pold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(v(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      cALL mpi_isend(u(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      cALL mpi_isend(p(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      cALL mpi_isend(vold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      cALL mpi_isend(uold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      cALL mpi_isend(pold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif 
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(12,req,istat,ierr)
      endif

      if(taskid.eq.numtasks-1)then                        
      cALL mpi_irecv(v(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(u(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      cALL mpi_irecv(p(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      cALL mpi_irecv(vold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      cALL mpi_irecv(uold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      cALL mpi_irecv(pold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(v(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      cALL mpi_isend(u(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      cALL mpi_isend(p(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      cALL mpi_isend(vold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      cALL mpi_isend(uold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      cALL mpi_isend(pold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(12,req,istat,ierr)
      endif
      call f_hpmstop( 17 )
      CALL f_hpm_errchk

C
      RETURN
      END

      SUBROUTINE CALC3Z
C
C         TIME SMOOTHER FOR FIRST ITERATION
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
CME -----------------------------------------
      integer ierr

      TDT = TDT+TDT
      DO 400 J=js,je
      DO 400 I=1,MP1
      UOLD(I,J) = U(I,J)
      VOLD(I,J) = V(I,J)
      POLD(I,J) = P(I,J)
      U(I,J)    = UNEW(I,J)
      V(I,J)    = VNEW(I,J)
      P(I,J)    = PNEW(I,J)
      if(j.eq.n)then
      UOLD(I,J+1) = U(I,J+1)
      VOLD(I,J+1) = V(I,J+1)
      POLD(I,J+1) = P(I,J+1)
      U(I,J+1)    = UNEW(I,J+1)
      V(I,J+1)    = VNEW(I,J+1)
      P(I,J+1)    = PNEW(I,J+1)
      endif
  400 CONTINUE
      RETURN
      END
