/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#pragma comment(copyright,"5765-543 (C) Copyright IBM Corp. 2008 @(#) 1.2 src/ppe/hpct/source/examples/mp_profiler/cexamples/mpi_test.c, ppe.hpct, ppe_rhya 08/12/01 14:19:32")
#include <stdio.h>
#include <mpi.h>
#include <unistd.h>

#define MAXPOWER 20
#define LOOP 5

int main( int argc, char **argv)
{
  unsigned char msg[1<<MAXPOWER];
  int rank, size, right, left;
  int aktpower, msgsize, loop;
  MPI_Request req[2];
  MPI_Status stats[2];

  MPI_Init( &argc, &argv);
  MPI_Comm_rank( MPI_COMM_WORLD, &rank);
  MPI_Comm_size( MPI_COMM_WORLD, &size);

  right = (rank+1)      % size;
  left  = (rank-1+size) % size;

  /* init msg */
  for( msgsize=0; msgsize<(1<<MAXPOWER); msgsize++)
    msg[msgsize]=0;

  /* this generates messages with sizes of 2^(0...MAXPOWER) */
  for( aktpower=0; aktpower<=MAXPOWER; aktpower++)
    {
      msgsize=1<<aktpower;
      MPI_Isend( msg, msgsize, MPI_CHAR, 
		 right, 0, MPI_COMM_WORLD, &req[0]);   
      MPI_Irecv( msg, msgsize, MPI_CHAR, 
		 left , 0, MPI_COMM_WORLD, &req[1]);
      MPI_Waitall( 2, req, stats);
      /* and wait for all */
      MPI_Barrier(MPI_COMM_WORLD);
      /* wait again -> test for tracefile */
      if(rank==0)
	usleep(1);      
      MPI_Barrier(MPI_COMM_WORLD);
    }

  /* a simple barrier test */
  for( loop=0; loop<LOOP; loop++)
    {
      /* wait again -> test for tracefile */
      if(rank==0)
	sleep(1);      
      MPI_Barrier(MPI_COMM_WORLD);
    }

    
  MPI_Finalize();
  return 0;
}
