/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* "@(#) 1.2 src/ppe/hpct/source/src/mio/hpcMIO_user.h, ppe.hpct, ppe_rhya, rhyas001a 08/11/04 11:40:14" */
#if !defined(_MIO_USER_H )
#define _MIO_USER_H 

#if !defined(_LARGE_FILES)
#define _LARGE_FILES
#endif

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <aio.h>

#if !defined(MIO_STRUCT_AIOCB)
#define MIO_STRUCT_AIOCB struct aiocb64
#define MIO_STRUCT_LIOCB struct liocb64
#endif

#if defined(__linux__)
#define int64 long long
#endif

extern int MIO_open(char *, int, int, void *);
extern int MIO_open64(char *, int, int, void *);
extern int MIO_fstat64( int, struct stat64 *);
extern off_t   MIO_lseek(   int, off_t,   int);
#if defined __AIX__ || (defined(__linux__) && defined(_LARGEFILE64_SOURCE))
extern off64_t MIO_lseek64( int, off64_t, int);
#endif
extern int MIO_ftruncate64( int, int64);
extern int MIO_read( int, void *, int);
extern int MIO_write( int, void *, int);
extern int MIO_close( int);
extern int MIO_fcntl( int, int, int *);
extern int MIO_ffinfo( int, int, struct diocapbuf *, int);
extern int MIO_fsync( int);
extern int MIO_aio_read64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_aio_write64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_aio_suspend64( int , MIO_STRUCT_AIOCB ** ) ;
extern int MIO_aio_nwait64( int , int , MIO_STRUCT_AIOCB ** ) ;
extern int MIO_aio_cancel64( int , MIO_STRUCT_AIOCB * ) ;
extern int MIO_lio_listio64( int , MIO_STRUCT_LIOCB **, int , void *) ;

#if defined(USE_MIO_DEFINES)
#define open64(a,b,c)        MIO_open64(a,b,c,0)
#define close(a)             MIO_close(a)
#define read(a,b,c)          MIO_read(a,b,c)
#define write(a,b,c)         MIO_write(a,b,c)
#if defined __AIX__ || (defined(__linux__) && defined(LARGEFILE64_SOURCE))
#define lseek64(a,b,c)       MIO_lseek64(a,b,c)
#endif
#define ftruncate64(a,b)     MIO_ftruncate64(a,b)
#define fsync(a)             MIO_fsync(a)
#define fstat64(a,b)         MIO_fstat64(a,b)
#define ffinfo(a,b,c,d)      MIO_ffinfo(a,b,c,d)
#define fcntl(a,b,c)         MIO_fcntl(a,b,c)
#define aio_read64(a,b)      MIO_aio_read64(a,b)
#define aio_write64(a,b)     MIO_aio_write64(a,b)
#define aio_suspend64(a,b)   MIO_aio_suspend64(a,b)
#define aio_nwait(a,b,c)     MIO_aio_nwait64(a,b,c)
#define aio_cancel64(a,b)    MIO_aio_cancel64(a,b)
#define lio_listio64(a,b,c,d) MIO_lio_listio64(a,b,c,d)
#endif

#endif  /* _MIO_USER_H  */
