/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1993,2009          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef PM_EXTERNS_H
#define PM_EXTERNS_H
/* "@(#) 1.23.1.30 src/ppe/poe/include/pm_externs.h, ppe.poe.pm, ppe_rhya, rhyas003a 09/03/05 18:16:54\0" */
/****************************************************************************

 Name: pm_externs.h

 Description:    Usercodes set by poe command line flags, environment
                  variables or defaults. The naming convention for the
                  usercodes is a lowercase representation of the
                  associated environment variable. They are all allocated
                  in pm_common.c

 Licensed Materials - Property of IBM

 All rights reserved.
 US Government Users Restricted Rights - Use, Duplication or Disclosure
 restricted by GSA ADP Schedule Contract with IBM Corp.

 Function: Definition of variables which can be set by the user.  The
        general form is:
                mp_variablename corresponds to the environment variable
        MP_VARIABLENAME and to the command-line argument
          -variablename

 Notes: The actual definitions of the variables is in pm_common.c,
        unless otherwise indicated.

#private
 History:
   11/20/97 MO   Port to OS/390 Unix System Services (D35248)
   12/09/97 MO   mp_promptpw is USS specific         (D35875)
   02/11/98 GM   add mp_rmpoolname and mp_msg_api (F33035)
   02/19/98 AB   M01 add mp_rmpoolname for USS (D37347)
   03/17/98 GM   Added mp_nodes and mp_tasks_per_node (F33036)
   06/15/98 AJ   POE support for MP_FSTYPE env var (D39664) 
   07/16/98 AJ   Undo the support for MP_FSTYPE env var (D41993) 
   02/11/99 WG   Fix type of mp_coredir (D47377)                 
   05/19/99 GM   Added mp_llfile and mp_savellfile (F48027)
   05/21/99 CL   Added mp_ionodefile (D47965)
   06/29/99 CL   Added mp_corefile_format (F49297)
   06/10/99 GM   Added mp_pmd_version (F46440)
   02/14/01 CL   Added mp_corefile_sigterm (D70627)
   05/18/04 PFC  Added RDMA support (D109557)
   12/07/04 GJM  Added mp_rmlib (F113874)
   05/13/05 ECL  Remove MVS support code (D121517/F118850)
   05/15/05 ECL  Remove mp_spname (D121517/F118850)
   05/18/05 ECL  Remove OLD_PMD define (F118850)
   06/02/05 PFC  added user rCxt blocks support (F117359)
   06/08/05 PFC  added LL scheduling affinity support (F114284)
   12/12/05 PFC  Linux Infiniband Phase 2 support (F129202)
   10/28/07 PFC  P6 Affinity/OpenMP support (F144416)
   02/23/09 MYU  MP_SYNC_QP (D155980)
   
#eprivate

 ***************************************************************************/

extern int mp_procs;              /* number of processes */
extern char *mp_tmpdir;           /* temp output directory */
extern char *mp_hostfile;         /* name of host list file */
extern char *mp_tracefile;        /* name of trace file */
extern char *mp_configfile;       /* name of display config file */
extern int mp_infolevel;          /* message reporting level */
extern int mp_tracelevel;         /* trace reporting level */
extern int mp_retry;              /* wait for processors */
extern int mp_pmlights;           /* size of user-programmable monitor disp */
extern int mp_usrport;            /* port for API to user-program monitor */
extern int mp_samplefreq;         /* sampling frequency */
extern char *mp_tracedir;         /* directory for final trace file */
extern char *mp_tbuffwrap;        /* wraparound trace buffer */
extern unsigned int mp_tbuffsize; /* trace buffer size */
extern unsigned int mp_ttempsize; /* trace temporary filesize */
extern unsigned int mp_tpermsize; /* trace permanent filesize */
extern int mp_twrap;              /* wraparound flag (internal version of tbuffwrap) */
extern int mp_resd;               /* use Resource Manager for node allocation */
extern int mp_batch;              /* Batch (LoadLeveler) mode */
extern int mp_EOF_stdin;          /* Reserved for EOF signalling */
extern int mp_fence;              /* fence between POE and users options */ /* 23702 */
extern int mp_noarglist;          /* examine argument list */
extern char *mp_euilib;           /* eui library to use */
extern char *mp_euidevice;        /* adapter specification */
extern int mp_euidevelop;         /* EUI develop mode */
extern char *mp_vtlibpath;        /* VT tracing library */
extern int mp_newjob;             /* submit new PE jobs without exiting PE */
extern int mp_pmdlog;             /* use pmd logfile */
extern char *mp_savehostfile;     /* list of hosts from resource manager */
extern char *mp_cmdfile;          /* PE command file */
extern int mp_stdoutmode;         /* stdout mode */
extern int mp_stdinmode;          /* stdin mode */
extern int mp_labelio;            /* label output */
extern char *mp_euilibpath;       /* path to use for eui library (concatenated with mp_euilib) */
extern int mp_pgmmodel;           /* programming model 1 = SPMD, 0 = MPMD */
extern int mp_retrycount;         /* retry count for node allocation.  Default = 0 */
extern int mp_rmpool;             /* default pool ID for Resource Manager. Default = 0 */
extern char *mp_rmpoolname;	  /* pools can now be names, also used in USS now   M01*/
                                  /* Remove MVS support code */
extern int mp_cpu_use;		  /* indicates multiple or unique cpu usage */
extern int mp_adapter_use;	  /* indicates shared or dedicated adapter usage */
extern int mp_pulse;	          /* indicates poe pulse interval */
extern char *mp_coredir;          /* directory where core files reside */
extern int mp_msg_api;		  /* message protocol */
extern int mp_nodes;		  /* number of physical nodes for job */
extern int mp_tasks_per_node;	  /* number of tasks per mp_nodes */
extern char *mp_llfile;		  /* Name of LL JCF for interactive job */
extern char *mp_save_llfile;	  /* Saved JCF from interactive job */
extern char *mp_ionodefile;       /* name of I/O node file */
extern char *mp_corefile_format;  /* lightweight corefile format         */
extern int mp_corefile_sigterm;   /* lightweight corefile sigterm  */
extern char *mp_instances;	  /* number of adapter instances  */
extern int mp_use_bulk_xfer;      /* LAPI bulk data transfer  */
extern int mp_rdma_count;         /* RDMA context block count */
extern int mp_rdma_count_lapi;    /* RDMA context block count */
extern int mp_rdma_count_mpi;    /* RDMA context block count */
extern int mp_mcm_list_used;     /* LL scheduling affinity */
extern char *mp_rmlib;
extern char *mp_devtype;	 /* device type */
extern char *mp_rdma_mode;	  /* number of adapter instances  */
extern int mp_task_core;          /* P6 core affinity with OpenMP */
extern int mp_task_cpu;           /* P6 CPU affinity with OpenMP */
extern int mp_parallel_threads;   /* P6 OpenMP parallel threads  */
#if defined(LINUX) || defined(AIX_MDCR)
extern char *mp_physnet;
#endif
extern int mp_sync_qp;		/* MP_SYNC_QP yes/no */
#endif
